# -*- coding:Utf-8 -*-
# unscope_duel V.1.102p by DoCky (15/10/2009)


import es, psyco, langlib, popuplib, effectlib, playerlib, gamethread
psyco.full()

addon = es.AddonInfo()
addon.version = "1.102p"
addon.author = "DoCky"
addon.name = "unscope_duel"

version = es.ServerVar(addon.name, "", "by DoCky -")
version.set(addon.version)
version.makepublic()

cvWeapon = es.ServerVar("ud_weapon", "awp_knife", "unscope_duel: weapon(s) given to duelist")
cvHealth = es.ServerVar("ud_health", "100", "unscope_duel: player health at duel begining")
cvArmor = es.ServerVar("ud_armor", "100", "unscope_duel: player armor at duel begining")
cvBeam = es.ServerVar("ud_beam", "1", "unscope_duel: activate beam [0-1]")
cvTime = es.ServerVar("ud_time", "1", "unscope_duel: define time for battle [sec]")
cvKill = es.ServerVar("ud_kill", "1", "unscope_duel: kill duelist at end of allowed time [0-1]")
cvLast = es.ServerVar("ud_last", "1", "unscope_duel: give back player weapon at end of duel [0-1]")
cvDrop = es.ServerVar("ud_drop", "1", "unscope_duel: drop/remove unauthorized weapon when duel is running [0-1-2]")

language = langlib.Strings(es.ServerVar("eventscripts_gamedir") + "/cfg/unscope_duel/language.ini")
status = False
weapon = set()
timer = 0
duel = []



#############################
#  SYSTEM
def init():
    global language
    weapon.clear()
    es.server.cmd("es_xmexec unscope_duel/config.cfg")
    for item in str(cvWeapon).split(","): weapon.add(item.strip())
    language = langlib.Strings(es.ServerVar("eventscripts_gamedir") + "/cfg/unscope_duel/language.ini")

def ticker():
    try:
        global timer
        if timer:
                timer -= 1
                for player in duel: player.hint()
                gamethread.delayedname(1, "ud_timer", ticker)
        else: duelEnd()
    except: es.dbgmsg(0, "unscope_duel: cannot initialize timer")

class Duelist(object):
    def __init__(self, userid, userteam):
        if int(userteam) == 2: self.blue, self.red = 25, 255
        else: self.blue, self.red = 255, 25
        self.userid = int(userid)
        self.lastloc = 0
        self.radius = 40
        self.weapon = []
        self.loop = 0

    def __loop(self):
        if status:
            if self.loop < 20:
                if not self.loop % 2: self.lastloc = es.getplayerlocation(self.userid)
                effectlib.drawCircle(
                    (self.lastloc[0], self.lastloc[1], self.lastloc[2] + 45), self.radius, steps = 50,
                    width = 2, endwidth = 2, seconds = .1, green = 25, red = self.red, blue = self.blue,
                    model = "sprites/laserbeam.vmt", halo = "sprites/laserbeam.vmt")
                self.radius += 8
                self.loop += 1
                gamethread.delayed(.06, self.__loop)
            else: gamethread.delayed(1, self.beam)

    def init(self):
        for item in weapon: es.server.queuecmd("es_xgive %s weapon_%s" % (self.userid, item))
        es.setplayerprop(self.userid, "CCSPlayer.m_bHasHelmet", 1)
        es.setplayerprop(self.userid, "CCSPlayer.m_ArmorValue", cvArmor)
        es.setplayerprop(self.userid, "CBasePlayer.m_iHealth", cvHealth)

    def strip(self):
        if es.exists("userid", self.userid):
            es.server.cmd(
                "es_xfire %s player_weaponstrip kill;" % self.userid +
                "es_xentcreate %s player_weaponstrip;" % self.userid +
                "es_xfire %s player_weaponstrip strip" % self.userid)

    def beam(self):
        try:
            self.radius = 40
            self.loop = 0
            self.__loop()
            es.emitsound("player", self.userid, "buttons/blip2.wav", 1.0, 0.8)
        except: es.dbgmsg(0, "unscope_duel: cannot start new cycle of beam effect")

    def hint(self):
        if status:
            es.usermsg("create", "ud_timer", "HintText")
            es.usermsg("write", "byte", "ud_timer", 1)
            es.usermsg("write", "string", "ud_timer", "[%i]" % timer)
            es.usermsg("send", "ud_timer", self.userid, 0)
            es.usermsg("delete", "ud_timer")

        else:
            es.usermsg("create", "ud_timer", "ResetHUD")
            es.usermsg("write", "byte", "ud_timer", -1)
            es.usermsg("send", "ud_timer", self.userid, 1)
            es.usermsg("delete", "ud_timer")

    def last(self):
        player = playerlib.getPlayer(self.userid)
        self.weapon = [
            str(player.getPrimary()),
            str(player.getSecondary()),
            int(player.getHE()),
            int(player.getFB()),
            int(player.getSG()),
            int(player.hasNightvision()),
            int(player.hasDefuser()),
            int(player.hasC4())]

    def give(self):
        try:
            for slot in xrange(0, 2):
                if self.weapon[slot] != "0": es.server.queuecmd("es_xgive %s %s" % (self.userid, self.weapon[slot]))
            if self.weapon[2]:
                es.server.queuecmd("es_xgive %s weapon_hegrenade" % self.userid)
                es.setplayerprop(self.userid, "CBasePlayer.localdata.m_iAmmo.011", self.weapon[3])
            if self.weapon[3]:
                es.server.queuecmd("es_xgive %s weapon_flashbang" % self.userid)
                es.setplayerprop(self.userid, "CBasePlayer.localdata.m_iAmmo.012", self.weapon[3])
            if self.weapon[4]:
                es.server.queuecmd("es_xgive %s weapon_flashbang" % self.userid)
                es.setplayerprop(self.userid, "CBasePlayer.localdata.m_iAmmo.013", self.weapon[4])
            if self.weapon[7]: es.server.queuecmd("es_xgive %s weapon_c4" % self.userid)
            es.setplayerprop(self.userid, "CCSPlayer.m_bHasNightVision", self.weapon[5])
            es.setplayerprop(self.userid, "CCSPlayer.m_bHasDefuser", self.weapon[6])
        except IndexError: es.dbgmsg(0, "unscope_duel: weapon have not been recorded correctly")



#############################
#  DUELFUNC
def duelMenu(userid, index, popup):
    if index == 1: duel.append(Duelist(userid, es.getplayerteam(userid)))
    if len(duel) == 2: duelInit()

def duelInit():
    global status, timer
    status, timer = True, abs(int(cvTime))
    if int(cvDrop) == 2: weapon_remove()
    if timer: ticker()

    for player in duel:
        gamethread.delayed(.1, player.init)
        if int(cvLast): player.last()
        if int(cvBeam): player.beam()
        player.strip()

def duelEnd():
    global status, duel
    try: gamethread.cancelDelayed("ud_timer")
    except: es.dbgmsg(1, "unscope_duel: timer must be allready stoped")
    menu.unsend(playerlib.getUseridList("#alive"))
    for player in duel: player.hint()

    if status:
        if int(cvKill) and len(duel)== 2:
            for player in duel: es.sexec(player.userid, "kill")
        elif int(cvLast):
            for player in duel:
                 if not es.getplayerprop(player.userid, "CBasePlayer.pl.deadflag"):
                    gamethread.delayed(.5, player.strip)
                    gamethread.delayed(.6, player.give)
    status = False
    duel = []


#############################
#  EVENTS
def player_death(event):
    global status
    userct = playerlib.getUseridList("#alive,#ct")
    usert = playerlib.getUseridList("#alive,#t")
    if len(userct) == 1 and len(usert) == 1:
        if len(playerlib.getUseridList("#human,#alive")) == 2:
            for userid in userct + usert: menu.send(userid)
        else: es.dbgmsg(1, "unscope_duel: bots cannot use snipes without scope")
    elif status: duelEnd()

def item_pickup(event):
    if status and int(cvDrop):
        userid, item = event["userid"], event["item"]
        if not item in weapon: es.server.cmd("es_xsexec %s use weapon_%s;es_xcexec %s drop" % (userid, item, userid))

def weapon_remove():
    entity = es.createentitylist
    for index, entity in es.createentitylist().items():
        if entity["classname"].startswith("weapon_"):
            if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == -1: es.server.queuecmd("es_xremove %s" % index)

def weapon_zoom(event):
    if status: es.setplayerprop(event["userid"], "CBasePlayer.m_iFOV", 0)

def round_end(event):
    duelEnd()

def round_start(event):
    menu.unsend(playerlib.getUseridList("#alive"))
    status = False
    duel = []

def es_map_start(event):
    init()

def load():
    init()
    global menu
    menu = popuplib.create("ud_menu")
    menu.addline(language["title"])
    menu.addline(language["yes"])
    menu.addline(language["no"])
    menu.addline(language["exit"])
    menu.menuselect = duelMenu

def unload():
    menu.delete()
